##!perl -w
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2020-2021 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
# purpose: prefix the compilation/link cmd into makefile or eclipse compiler name
# for third party tools.
# It takes eclipse settings to define intrumentation options
# it use TDP's attolcc.pl to analyse compiler options and compile+instrument application sources
# it detect link step to generate TP, compil it and link it to other files
#note the previous script in this file was for IECLISPE which is not anymore used since 8.0.1
#################################################################################


# useful for stdout/stderr direct viewing inside 'console' of studio window
# (better: we have stdout/stderr lines in right order and not stderr before stdout
use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

## globals ############
$main::TestRTCC=1;
#######################
$main::SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "BatchCCDefaults.pl";

my $tmpdir;
my $nodeSettings="envTestRTcc.pl";
if(defined $ENV{TESTRTCC_CONFIG} && (-f $ENV{TESTRTCC_CONFIG})){
	require $ENV{TESTRTCC_CONFIG};
} else {
	if($^O=~/win32/i) {
		$tmpdir=$ENV{'HOMEDRIVE'}.$ENV{'HOMEPATH'};
		unless(($tmpdir) && (-f "$tmpdir/$nodeSettings")){
			$tmpdir=$ENV{'USERPROFILE'};
			unless(($tmpdir) && (-f "$tmpdir/$nodeSettings")){
			$tmpdir=$ENV{'TEMP'} ;
			$tmpdir=$ENV{'TMP'} unless($tmpdir);
		}
		}
	}else{
		$tmpdir=$ENV{'HOME'};
		$tmpdir=$ENV{'TMPDIR'} unless($tmpdir);
		$tmpdir='/tmp' unless($tmpdir);
	}

	my $envnode="$tmpdir/$nodeSettings";
	if(-f $envnode) {
		require $envnode;
		$CFLAGS=1 if($USE_CFLAGS_TP);
	} else {
		print STDERR "$envnode not found. Launching command.\n";
		my $ret=system(@ARGV);
		exit($ret);
	}
}
unless($RTRT_ACTIVATED){
# do not print anything when using original command
#	print "No instrumentation required. Launching command.\n" if($ENV{'ATTOLSTUDIO_VERBOSE'});
	my $ret=system(@ARGV);
	exit($ret);
}

if($TARGETDIR) {
	$ENV{'ATLTGT'} =$TARGETDIR;
} else {
	$main::TARGETDIR=$ENV{'ATLTGT'};
}
#print "use TDP $TARGETDIR\n";
die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
die "$main::TARGETDIR/cmd/attolcc.pl does not exist !!!\n" unless(-f $main::TARGETDIR . "/cmd/attolcc.pl");

# compute instrum option regarding environment file
require $main::SCRIPTDIR."Fcts.pl";
require $main::SCRIPTDIR."instrum.pl";
$instrumOpt = BuildCCppInstrOptions($TDP_LANGUAGE,"","","");

require $main::TARGETDIR . "/cmd/attolcc.pl";

1;
