##########################################################################
#                                                                        # #
# One Test Embedded                                                      #   #
#                                                                        #######
#                 -*- justify TIO generation -*-                               #
#                                                                              #
#                                                                              #
################################################################################

# To do output in chronological order when stderr and stdout are both used
use FileHandle ;
use File::Spec;
BEGIN {
  if ($^O eq "MSWin32") {
   use File::DosGlob 'glob';
 }
}
STDOUT->autoflush(1);
STDERR->autoflush(1);

$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Fcts.pl"; 
my %covJustif;
my %covJustidx;
my %covTable;
my %covTableidx;
my $tiohandle;
my $tioJustify="justify.tio";
sub genJustifyFDC
{
my $fdcList=shift;
$tiohandle = FileHandle->new ();

foreach my $f (@$fdcList){

  my $justif=0;
  my %CElines;
  my $lastCEline;
  my $prevProcends=0;
  my $tioIsOpen=0;
  %covJustif= ();
  %covJustidx= ();
	if(open(FDC,$f)){
	   while(<FDC>) {
	      if(/^EJ (\d+) (\d+) (\d+)\s+(.+)$/) { 
		    print "Justifications found in $f\n" unless($justif);
			$justif++;
			my $line=$2;
			my $jRecs=$4; #print $jRecs,"\n";
			while($jRecs=~s/\(([^\(\)]+)\)//) {#print $1,"\n";
				my @param=split(/,/,$1);
				my $nbParam=scalar(@param);
				my $offset=0;
				my $whatlist=' ';
				my $text='Unreachable';
				my $type;
				foreach my $p (@param) { 
						$p=~s/^\s*\"?//; $p=~s/\"?\s*$//;
				}
				if(($param[0] =~m/^\d+$/) || ($param[0] eq '')) {$offset=shift(@param);$nbParam--;}
				$type=shift(@param);
				if($nbParam==3) {($whatlist,$text)=@param;}
				elsif($nbParam==2) {
					my $p=shift(@param);
					if($p=~m/[:;\/]/) {
						$whatlist=$p; 
					} else {
						$text=$p;
					}
				}
				else {
					print STDERR "Bad number of parameter in pragma, at line $line\n" unless($nbParam==1);
				}
				#print ">>>>>>$whatlist";
				$offset=0 if($offset eq '');
				$whatlist=' ' if($whatlist eq ''); #print " >$whatlist<\n";
				$type='simple' if($type eq 'branch' || $type eq 'block');
				$type='logical' if($type eq 'while' || $type eq 'for');
				foreach my $what (split(/;/,$whatlist)) {
					my $idx=$covJustidx{$type}++;
					$what=~s/^\s*|\s*$//g;
					#print $idx,"($what)($type)\n";
					$covJustif{$type}[$idx]{applied}=0;
					$covJustif{$type}[$idx]{line}=$line+$offset;
					$covJustif{$type}[$idx]{offset}=$offset;
					$covJustif{$type}[$idx]{what}=$what;
					$covJustif{$type}[$idx]{text}=$text;
				}
			}
		  } else {
		    next if(/^(VE|FC|FD|TC)/);
		    last unless($justif);
			if(/^BL (\d+) (\w+) \"([^\"]*)\" ([^ ]+) (\d+) (\d+)/){
				my $scope=0;
				$scope=1 if($5 eq $6);
				if($2 eq 'implicit') {$scope=2;}
				elsif($2 eq 'logical') {$scope=4;}
				testAround($1,$2,$5,$6,'B',$scope,$4);
			}
			elsif(/^PR (\d+) (proc) \"([^\"]*)\" (\d+) (\d+)/){
				testAround($1,$2,$prevProcends+1,$5,'P',1,$3);
				$prevProcends=$5;
			}
			elsif(/^PR (\d+) (\w+) \"([^\"]*)\" (\d+) (\d+)/){
				testAround($1,$2,$4,$5,'P',1,$3);
			}
			elsif(/^CE (\d+) \"([^\"]*)\" \"([^\"]*)\" (\d+) (\d+)/){
				$CElines{$1}=$4;
				$lastCEline=$5;
				testAround($1,'cond',$4,$5,'E',3,$3);
			}
			elsif(/^CC (\d+) (\d+) (\d+) ([ \d]+) (\d+) ([TFX]+) (\d+)$/){
			#CC 50 5 40 42 44 46 48 10 TTXXTTFTTTFXTTTTTXXFTFTTFFXTTFTFTFXTFFXXFXTFXFXFXX 3
				my $line=$_;
				my $id=$1;
				my $nbcond=$2;
				my $firstcond=$3;
				my $nbpatern=$5;
				my @patern=( $6 =~ m/[TFX]{$nbcond}/g );
				#print "   $line >>CC id $id nbCond $nbcond begin $CElines{$firstcond} end $lastCEline nbPatern $nbpatern >",join(';',@patern),' found ',scalar(@patern),"\n";
				testAround($id,'mcdc',$CElines{$firstcond},$lastCEline,'E',5,\@patern);
				%CElines=();
			}
			elsif(/^CC (\d+) (\d+) (\d+) ([ \d]+) (\d+) ([OoAaN.]+)$/){
			#CC 8 4 0 2 4 6 16 OAN..A.N.
				my $line=$_;
				my $id=$1;
				my $nbcond=$2;
				my $firstcond=$3;
				my $nbpatern=$5;
				my @patern;
				#print "   $line >>CC id $id nbCond $nbcond begin $CElines{$firstcond} end $lastCEline nbPatern $nbpatern\n";
				my $pi=$nbpatern;
				my $pf='%0'.$nbcond.'b';
				while($pi){
					$pi--;
					my $pat=scalar reverse(sprintf($pf,$pi));
					$pat=~tr/01/FT/;
					#print "patern $pi $pat\n";
					unshift(@patern,$pat);
				}
				testAround($id,'mcdc',$CElines{$firstcond},$lastCEline,'E',5,\@patern);
				%CElines=();
			}
			elsif(/^AP (\d+) \"([^\"]*)\" \"([^\"]*)\" (\d+) (\d+)/){
				testAround($1,'call',$4,$5,'A',1,$3);
			}
			elsif(/^CA (\d+) \"([^\"]*)\" \"([^\"]*)\" (\d+) (\d+)/){
				testAround($1,'case',$4,$5,'E',1,$3);
			}
			elsif(/^EK (\d+) (\d+)/) {dumpJustif($1,$2); last;}
		  }
	   }
	   printJustifies($f) if($justif);
	   close FDC;
	}
  }
  if($tioIsOpen){
    close $tiohandle ;
    return "$INTDIR/$tioJustify";
  }
  return '';
}

sub testAround
{
my $id=shift;
my $type=shift;
my $begin=shift;
my $end=shift;
my $table=shift;
my $scope=shift; #0=inside block begin to end #1=between begin-1 to end+1  #others =begin+-1 OR end+-1 #3|4 gets value from {what}
my $what=shift;
my $found=0;#print ">>>>$type $covJustidx{$type}\n";
	if($covJustidx{$type}){ 
	for my $idx (0 .. $covJustidx{$type}-1) {
		my $line=$covJustif{$type}[$idx]{line};
		my $inScope=($begin == $line);
		if(0 == $covJustif{$type}[$idx]{offset}){
			if($scope==0) {
				$inScope=($line >= $begin) && ($line <= $end);
				#print ">>>scope 0 >$line ($covJustif{$type}[$idx]{text}) $type $begin $end =>$inScope id $id,\n";
			} elsif($scope==1) {
				$inScope=($line >= $begin-1) && ($line <= $end+1);
				#print ">>>scope 1 >$line $type $begin $end =>$inScope id $id\n";
			} else {
				$inScope=($line == $begin-1) || ($line == $begin+1) || ($line == $end-1) || ($line == $end+1);
				#print ">>>scope $scope >$line $type $begin $end =>$inScope id $id\n";
			}
		}
		if($inScope)
		{   #print "$id $type: $idx $line=>$begin .. $end (scope $scope) (what $what)\n";
			my $w=$covJustif{$type}[$idx]{what};
			if($scope>=0 && $scope<=2) {
				$found=1 if(($w eq '') || ($what=~m/\Q$w\E$/));
				#print "--- found $found '$w' == '$what' ---\n";
			}
			elsif($scope==3) {
				my $v;
				($w,$v)=split(/:/,$w);
				if($v eq 'false'){$id++;}
				elsif($v ne 'true'){
					my $pragmaline=$covJustif{$type}[$idx]{line}-$covJustif{$type}[$idx]{offset};
					print STDERR "the pragma cov_justify line:",$pragmaline," type:",$type," must specify :true|false at end of {what} field. :true is assumed\n";
				}
				$found=1 if(($w eq '') || ($what=~m/\Q$w\E$/));
			}
			elsif($scope==4) {
				if($w eq '') {
					my $pragmaline=$covJustif{$type}[$idx]{line}-$covJustif{$type}[$idx]{offset};
					print STDERR "the pragma cov_justify line:",$pragmaline," type:",$type," must specify /0|1|2+ at end of {what} field. /0 is assumed\n";
					$w='/0';
				} else {
					$w=~s/2$/2+/;
				}
				$found=1 if($what=~m/\Q$w\E$/);
			}
			elsif($scope==5) {
				#print ">>>id:$id ",join(';',@$what),' ',scalar(@$what)," $begin .. $end\n";
				my $index = 0;
				foreach my $pat (@$what){
					if($pat eq $w){
						#print "justification found $pat is $w index=$index id=$id\n";
						justifound($type,$idx,$table,$id+$index,$begin,$end);
						last;
					} elsif($pat=~m/X/) {
						my $patreg=$pat; $patreg=~s/X/./g;
						if($w=~m/$patreg/){
							#print "justification found $pat match $w index=$index id=$id\n";
							justifound($type,$idx,$table,$id+$index,$begin,$end);
							last;
						}
					}
					$index++;
				}
			}
			#print ":::$begin..$end($scope): $what ?? \Q$w\E \n";
			if($found) {
				$found=0;
				justifound($type,$idx,$table,$id,$begin,$end);
				last;
			}
		}
	}}
}

sub justifound 
{
my $type=shift;
my $idx=shift;
my $table=shift;
my $id=shift;
my $begin=shift;
my $end=shift;
my $pragmaline=$covJustif{$type}[$idx]{line}-$covJustif{$type}[$idx]{offset};
	if($covJustif{$type}[$idx]{applied}){
		print STDERR "pragma justification at line $pragmaline ($type,",$covJustif{$type}[$idx]{what},',',$covJustif{$type}[$idx]{text},")\n\t is ambigous and could be applied code lines $begin to $end. It has been applied to code line ",$covJustif{$type}[$idx]{applied},"\n" if($pragmaline > $covJustif{$type}[$idx]{applied} && $pragmaline < $begin);
	} else {
		my $idxT=$covTableidx{$table}++;
		$covTable{$table}[$idxT]{id}=$id;
		$covTable{$table}[$idxT]{text}=$covJustif{$type}[$idx]{text};
		$covTable{$table}[$idxT]{pline}=$pragmaline;
		$covTable{$table}[$idxT]{tline}=$begin;
		$covTable{$table}[$idxT]{what}=$covJustif{$type}[$idx]{what};
		#mark justif as used
		$covJustif{$type}[$idx]{applied}=$begin;
		#print info
		my $w=$covJustif{$type}[$idx]{what}; $w='('.$w.')' if($w ne '');
		my $t=$covJustif{$type}[$idx]{text};
		print "$type justification $w as '$t' is applied to code lines $begin to $end with id $id\n";
	}
}

sub printJustifies
{
my $f=shift;#FDC file
	foreach my $type (keys %covJustif){
	if($covJustidx{$type}){
		for my $idx (0 .. $covJustidx{$type}-1) {
			unless($covJustif{$type}[$idx]{applied}){
				# printing key and value
				my $pragmaline=$covJustif{$type}[$idx]{line}-$covJustif{$type}[$idx]{offset};
				my $o=$covJustif{$type}[$idx]{offset};
				my $w=$covJustif{$type}[$idx]{what};
				my $t=$covJustif{$type}[$idx]{text};
				print STDERR "\tline $pragmaline ($o,$type,$w,$t) not applied\n";          
	}}}}
}

sub dumpJustif
{
my $key=scalar reverse(sprintf("%x", shift));
my $cks=scalar reverse(sprintf("%x", shift));
if(%covTableidx) {
  if($tioIsOpen || open($tiohandle,">$INTDIR/$tioJustify")){
	print $tiohandle "NT \"justifies\" 0 0\nDT 0\nCO \"justifies\"\n" unless($tioIsOpen);	
    $tioIsOpen=1;
	print $tiohandle "FT $key\nDC $cks\n";
	foreach my $t (keys %covTable) {
		if($covTableidx{$t}){
			for my $idx (0 .. $covTableidx{$t}-1) {
				my $h = scalar reverse(sprintf("%x",$covTable{$t}[$idx]{id}));
				my $pl= scalar reverse(sprintf("%x",$covTable{$t}[$idx]{pline}));
				my $tl= scalar reverse(sprintf("%x",$covTable{$t}[$idx]{tline}));
				my $wt = $covTable{$t}[$idx]{what};
				my $jstf=$covTable{$t}[$idx]{text};
				print $tiohandle "T$t $h \"$jstf\" $pl $tl \"$wt\"\n";
	}}}}
	%covTableidx= ();
	%covTable= ();
}}

sub cov_justify_help
{
my ($dirlauncher,$launcherBase,$extl)=SplitFileName($0);
    print STDERR "#?$SMALL_PRODUCT_NAME-I-".uc($launcherBase).", Usage:  $launcherBase *.fdc\n";
}

#executed when launched in command line
sub covJustify
{
ReadProductName();
$INTDIR="." unless($INTDIR);
print STDERR "#?$SMALL_PRODUCT_NAME-I-covJustify\n";
 if(@ARGV) {
	if($ARGV[0]=~m/-help/i) {
		cov_justify_help();
		return(0);
	} 
 } else {
	cov_justify_help();
	return(0);
 }

 my @FDCFILES;
 foreach my $f (@ARGV)
 {
  if(-f $f && $f=~m/.fdc$/i){
	push(@FDCFILES,$f);
  } elsif($f=~m/\*/) {
		my @files = glob $f;
		push(@ARGV,@files );
  } else {
    print "Unused arg: $f\n" if($f ne '');
  }
 }
  
 my $out=genJustifyFDC(\@FDCFILES);
 if($out eq '') { print "No Justifications found in FDC files\n"; }
 else {print "Justifications found and generated into $out\n"; }
 return 0;
}

exit(covJustify()) if($0 =~m/(covJustify)/);
1;
