

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: Stack Size Library Source (included by TP.c[pp]) $
*******************************************************************************/


/*******************************************************************************
* Global variables
*******************************************************************************/

/* Header of linked-list */
RTRT_GLOBALVAR _atg_TP _atg_first;
RTRT_STATICVAR char _atg_test_started;
/*******************************************************************************
*  Service: _atg_dump
*******************************************************************************/
_ATL_C_GLOBALFCT void _atg_dump
#if !RTRT_KR
( int reset )
#else
( reset )
  int reset;
#endif
{
  _atg_TP thedata;
  RTRT_U_INT16 i;
  RTRT_U_INT16 v;
  RTRT_U_INT8 *pData8;
  RTRT_U_INT16 *pData16;
  RTRT_U_INT8 DataSizeof;
  RTRT_U_INT8 printHead;
  if ( reset & _ATCPQ_CCOUPLING)
  {

	  RTRT_MT_CRITICAL_VAR_LOCK(atl_line_mutex)
	  if(!_atg_test_started)
	  {
		  ATL_LINE_ADD_OPCODE ( ATL_TPF_CD );
		  atl_line_dump ( );
		  _atg_test_started=1;
	  }
	  
	  ATL_LINE_ADD_OPCODE ( ATL_TPF_CT );
	  _atl_obstools_test_name ( );
#if USE_ATV || USE_ATU
	  _ata_dump_uint(_atu_num_current_test);
	  _ata_dump_uint(_atu_num_current_op);
#endif
	  atl_line_dump ( );

	  for ( thedata = _atg_first;
			thedata>(_atg_TP)1;
			thedata = thedata->Next )
	  {
		printHead=0;
		DataSizeof=thedata->DataSizeof-1;
		if(DataSizeof)
		 pData16 =(RTRT_U_INT16 *)thedata->Data;
		else
		 pData8  =(RTRT_U_INT8 *)thedata->Data;

		for ( i = 0; i < thedata->NbPath; i++ )
		{
			if(DataSizeof)
			{
				v=pData16[i];
				if( reset & _ATCPQ_RESET_CCOUPLING)
					pData16[i]=0;
			}
			else
			{
			    v=pData8[i];
				if( reset & _ATCPQ_RESET_CCOUPLING)
					pData8[i]=0;
			}
			if(v)
			{
				if(printHead==0)
				{
					ATL_LINE_ADD_OPCODE ( ATL_TPF_CF );
					_ata_dump_uint(thedata->Source->Key);
					_ata_dump_uint(thedata->Source->CheckSum);
					atl_line_dump ( );
					printHead=1;
				}
				ATL_LINE_ADD_OPCODE ( ATL_TPF_CP );
				_ata_dump_uint(i);
				_ata_dump_uint(v);
				atl_line_dump ( );
			}
	    }
	  }
	  RTRT_MT_CRITICAL_VAR_UNLOCK(atl_line_mutex)
  }
}
/*******************************************************************************
*  remove data for a source Family
*******************************************************************************/
#ifdef ATL_T_FAMILY
void _atg_remove_family
#if !RTRT_KR
(ATL_T_FAMILY family)
#else
(family)
ATL_T_FAMILY family;
#endif
{
#if !ATL_DYN_TABLE

  _atg_TP thedata,dataPrev;
   thedata = _atg_first;
    while((thedata) && (thedata->Source->Family == family))
    {
		thedata = thedata->Next;
	}
	_atg_first = thedata;
    dataPrev = thedata;
	while(thedata)
	{
       if(thedata->Source->Family == family)
       {
	 	 dataPrev->Next = thedata->Next;
	   }
	   else
	   {
		   dataPrev = thedata;
	   }
	   thedata = thedata->Next;
	}
#endif /* ATL_DYN_TABLE */
}
#endif

/*******************************************************************************
*  Service: atg_set
*  Goal: set source local var
*******************************************************************************/
_ATL_C_GLOBALFCT void atg_set
#if !RTRT_KR
( _AtlStackLinkP stack_link, void * path_table , _atg_TP thedata,RTRT_U_INT16 pathNum)
#else
( stack_link, path_table, thedata, pathNum)
  _AtlStackLinkP stack_link;
  void * path_table;
  _atg_TP thedata;
  RTRT_U_INT16 pathNum;
#endif
{
	RTRT_U_INT8 *pPathTable8=(RTRT_U_INT8 *)path_table;
	RTRT_U_INT16 *pPathTable16=(RTRT_U_INT16 *)path_table;
	RTRT_U_INT8 *pData8=(RTRT_U_INT8 *)thedata->Data;
	RTRT_U_INT16 *pData16=(RTRT_U_INT16 *)thedata->Data;
	_AtlStackLinkP link;
    RTRT_U_INT16 im;
    RTRT_U_INT16 i;
    RTRT_U_INT16 p=0;
    RTRT_U_INT16 len=0;
    RTRT_U_INT16 cpid;
#if ATG_DUMP_PATH
    char dump;
#endif
  RTRT_U_INT8 DataSizeof=thedata->DataSizeof-1;

  if ( thedata->Next ==0 )
  {
    thedata->Next = _atg_first;
    _atg_first = thedata;
    for ( i = 0; i < thedata->NbPath; i++ )
    {
      if(DataSizeof)
     	 pData16[i] = (RTRT_U_INT16)0;
      else
         pData8[i]  = (RTRT_U_INT8)0;
    }
  }
  /* analyse path_table and stack_link to set thedata->Data */
  im=0;
  do
  {
	  p+=len;
	  if(DataSizeof)
		 len=pPathTable16[p];
	  else
		 len=(RTRT_U_INT16)pPathTable8[p];

	  link=stack_link->Up;
	  i=1;
	  while(link && i<=len)
	  {
		  if(DataSizeof)
			 cpid=pPathTable16[p+i];
		  else
			 cpid=(RTRT_U_INT16)pPathTable8[p+i];

		  if( link->Info.CallId != cpid )
		  /* ici on peut remonter pour chercher une correlation mais s'arreter sur un callId=0 */
			break;
		  link=link->Up;
		  i++;
	  }
	  if(i>im)
	  {
		  im=i;
		  /* update result for that path */
		  if(DataSizeof)
		  {
				 if( pData16[pathNum] <(RTRT_U_INT16)i)
				 {
					 pData16[pathNum] =(RTRT_U_INT16)i;
				 }
		  }
		  else
		  {
				 if( pData8[pathNum] <(RTRT_U_INT8)i)
				 {
					 pData8[pathNum] =(RTRT_U_INT8)i;
				 }
		  }
		  /* if we have seen the complete call stack for the compilation unit
		   * meaning the complete described path has been covered
		   * then don't need to check for other described paths */
		  if(link ==0 || link->Info.CallId ==0)
		  { /* short cut other path analyse if that path match the complete call stack */
				len=0;
#if ATG_DUMP_PATH
				dump=0;
		  } else {
				dump=1;
#endif
		  }
	  }
	  pathNum++;
  } while(len);
#if ATG_DUMP_PATH
  if(dump)
	  _ata_stack_dump(stack_link,-1);
#endif

}

/*******************************************************************************
*  Service: atg_early_init
*  Goal: initializes global variables
*******************************************************************************/
_ATL_C_GLOBALFCT void atg_early_init
#if !RTRT_KR
( void )
#else
( )
#endif
{
#if ! RTRT_RAM_CLEAN
  _atg_first = (_atg_TP)1;
  _atg_test_started=0;
#endif
}

/*******************************************************************************
*  Service: atg_late_exit
*  Goal: called when it is time to quit
*******************************************************************************/
_ATL_C_GLOBALFCT void atg_late_exit
#if !RTRT_KR
( void )
#else
( )
#endif
{
#if ! USE_ATU && ! USE_ATO && ! USE_ATV
  _atg_dump ( _ATCPQ_ALL );
#endif /* USE_ATU && USE_ATO */
}

