
/*
 *  Licensed Materials - Property of HCL
 *  Restricted Material of HCL
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#define MNT_UNSIGNED_IMGE(t,p,r) RTRT_CONCAT_MACRO(unsigned_,t) ((_ATL_LARGEST_U_INT)p, r)
#define MNT_INTEGER_IMGE(t,p,r)  RTRT_CONCAT_MACRO(integer_,t)  ((_ATL_LARGEST_INT)p, r)

#define MNT_UNSIGNED_IMAGE(p,r) MNT_UNSIGNED_IMGE(MNT_IMAGE_INT,p,r)
#define MNT_INTEGER_IMAGE(p,r)  MNT_INTEGER_IMGE(MNT_IMAGE_INT,p,r)
#define debug2(f,p) printf(f,p);

#if MNT_IO == RTRT_SOCKET

#ifndef MNT_INPUT_BUFFER_SIZE
#define MNT_INPUT_BUFFER_SIZE 500
#endif

#ifndef MNT_HOST_ADDRESS_PORT
#define MNT_HOST_ADDRESS_PORT ATL_HOST_ADDRESS_PORT+1
#endif /*MNT_HOST_ADDRESS_PORT*/
#ifndef RTRT_SOCKET_INCLUDES
#include <stdlib.h>
#include <stdio.h>
#ifdef _WIN32
#include <windows.h>
#include <winbase.h>
#include <winsock.h>
#endif /*_WIN32*/
#ifndef _MSC_VER /* do not use following include files for MS visuals */
#include <unistd.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <sys/types.h>
#include <netdb.h>
#endif /* _MSC_VER */
#define RTRT_SOCKET_INCLUDES
#endif /* RTRT_SOCKET_INCLUDES */
#define MNT_FILE_TYPE int 

#elif MNT_IO == RTRT_USR
#ifndef MNT_INPUT_BUFFER_SIZE
#define MNT_INPUT_BUFFER_SIZE 100
#endif
#ifdef RTRT_MNT_FILE_TYPE /* can be defined by TDP */
#define MNT_FILE_TYPE RTRT_MNT_FILE_TYPE
#else
#define MNT_FILE_TYPE int
#endif /*RTRT_MNT_FILE_TYPE*/

extern void mnt_usr_send(MNT_FILE_TYPE mnt_conn,char*str,int len);
extern int  mnt_usr_get_request(MNT_FILE_TYPE mnt_conn,char *buffer, int maxlen, int timeout);
extern MNT_FILE_TYPE mnt_usr_open(char*fileName);
extern void mnt_usr_close(MNT_FILE_TYPE mnt_conn);

#elif MNT_IO == RTRT_STD

#ifndef MNT_INPUT_BUFFER_SIZE
#define MNT_INPUT_BUFFER_SIZE 100
#endif

#define MNT_FILE_TYPE FILE* 
#endif /* MNT_IO */

#ifdef MNT_FILE_TYPE
MNT_FILE_TYPE mnt_conn;
#endif /*MNT_FILE_TYPE*/

#ifndef MNT_CYCLE
#define MNT_CYCLE 10
#endif

#ifndef MNT_OUT_BUFFER_SIZE
#define MNT_OUT_BUFFER_SIZE 50
#endif

#if MNT_OUT_BUFFER_SIZE >0
char mnt_out_buffer[MNT_OUT_BUFFER_SIZE];
#endif

#ifdef MNT_INPUT_BUFFER_SIZE
#if MNT_INPUT_BUFFER_SIZE >0
char mnt_input_buffer[MNT_INPUT_BUFFER_SIZE];
#endif
#endif
//based on EDG an_integer_kind_tag
// here is the list of know basic types of variables
enum atl_type_kind {
  atk_none, //=0
  atk_char, //1
  atk_signed_char,
  atk_unsigned_char,
  atk_short,  //4
  atk_unsigned_short,
  atk_int, //6
  atk_unsigned_int, //7
  atk_long, //8
  atk_unsigned_long,
  atk_long_long, //10
  atk_unsigned_long_long,
  atk_int128, //12
  atk_unsigned_int128,
  atk_int32,  //14           
  atk_unsigned_int32, //=15   

  atk_float,  //=16
  
  atk_double, //17            
  atk_long_double, //18  
  atk_string, //19  
  atk_last 
};
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
RTRT_U_INT16 mnt_cycle;
RTRT_U_INT16 mnt_frequency;
typedef struct smnt_CyclicTable {
	RTRT_U_INT16 idxR;
	RTRT_U_INT16 idxF;
	RTRT_INT8 idxDataType;
	char *addressVar;
	struct smnt_CyclicTable * Next;
} *_AtlCyclicTableP;
_AtlCyclicTableP mnt_CyclicTableTop=0;

void mnt_Push2CyclicTable(RTRT_U_INT16 idxR, RTRT_U_INT16 idxF,RTRT_INT8 idxDataType, char *addressVar)
{
	_AtlCyclicTableP m=(_AtlCyclicTableP)priv_malloc(sizeof(struct smnt_CyclicTable));
	m->idxR=idxR;
	m->idxF=idxF;
	m->idxDataType=idxDataType;
	m->addressVar=addressVar;
	m->Next=mnt_CyclicTableTop;
	mnt_CyclicTableTop=m;
	printf("add one cyclic\n");
}

#else //MNT_CYCLIC_ALLOWED
#define mnt_Push2CyclicTable(R,F,T,a)
#endif //MNT_CYCLIC_ALLOWED
_ATL_LARGEST_U_INT buf2uint(char *in,int*len)
{
  _ATL_LARGEST_U_INT v=0;
  if(in)
  {
	while(*in==' ' || *in=='+') {in++;(*len)++;}
	while(*in>='0' && *in<='9') {v=v*10+ (*in++) - '0';(*len)++;}
  }
  return v;
}
_ATL_LARGEST_INT buf2int(char *in,int*len)
{
  _ATL_LARGEST_INT v=0;
  if(in)
	  if(*in=='-') {(*len)++;return -((_ATL_LARGEST_INT)buf2uint(++in,len));}
  return ((_ATL_LARGEST_INT)buf2uint(in,len));
}

#if MNTUSE_DOUBLE && defined NEEDS_long_double_image
#define NEEDS_priv_atof_type long double
#ifndef ATL_POW10
#ifndef _MSC_VER
#define ATL_POW10(x) powl(10.0,x)
#else
#define ATL_POW10 pow10l
#endif
#endif /*ATL_POW10*/
#else
#if  MNTUSE_DOUBLE && defined NEEDS_double_image
#define NEEDS_priv_atof_type double
#ifndef ATL_POW10
#ifndef _MSC_VER
#define ATL_POW10(x) pow(10.0,x)
#else
#define ATL_POW10 pow10
#endif
#endif /*ATL_POW10*/
#else
#if  MNTUSE_FLOAT && defined NEEDS_float_image
#define NEEDS_priv_atof_type float
#ifndef ATL_POW10
#ifndef _MSC_VER
#define ATL_POW10(x) powf(10.0,x)
#else
#define ATL_POW10(x) powf(10.0,x)
#endif
#endif /*ATL_POW10*/
#endif /*MNTUSE_FLOAT*/
#endif /*MNTUSE_DOUBLE*/
#endif /*MNTUSE_DOUBLE NEEDS_long_double_image*/


#ifdef NEEDS_priv_atof_type
#include <math.h>
void atl_pow10(int e,NEEDS_priv_atof_type *f)
{
	NEEDS_priv_atof_type r = 1.0;
	if (e>0 && e < 1000)
	{
#if MNTUSE_DOUBLE
		while (e >= 100){ e -= 100; r *= 1.0e100; }
#endif
		while (e >= 10){ e -= 10; r *= 1.0e10; }
		while (e >= 1){ e -= 1; r *= 1.0e1; }
	}
	else if (e<0 && e > -1000)
	{
#if MNTUSE_DOUBLE
		while (e <= -100){ e += 100; r *= 1.0e-100; }
#endif
		while (e <= -10){ e += 10; r *= 1.0e-10; }
		while (e <= -1){ e += 1; r *= 1.0e-1; }
	}
	*f = r;
}

void priv_atof(char *in,int *len,NEEDS_priv_atof_type *result)
{
	int l;
	NEEDS_priv_atof_type val=0.0;
	NEEDS_priv_atof_type unit=10.0;
	int decimal=0;
	while(*in >='+' && *in <='9' || (*in&0xDF) =='E') 
	{
		if(*in>='0' && *in<='9')
		{
			if(decimal)
			{
				val = val + ((NEEDS_priv_atof_type)((int)((*in++)-'0'))/unit);
				unit=unit*10.0;
			}
			else
				val = val * (NEEDS_priv_atof_type)10.0 + (NEEDS_priv_atof_type)((int)((*in++)-'0'));
		}
		else switch(*in++)
		{
			case '-':val=-val;
			case '+':
			case ' ':
					break;
			case '.':
				decimal=1;
				break;
			case 'e':
			case 'E':
				atl_pow10(buf2int(in,len),&unit);
				*result= val*unit;
				return;
			default:
			*result= val;
			return;
		}
		(*len)++;
	}
	*result=val;
}
#endif /*NEED_priv_atof*/

RTRT_U_INT16 mnt_sizeOfElement(RTRT_U_INT16 idxF,RTRT_INT16 idxT)
{
	if(idxT<0)
	{
		enum atl_type_kind s=(enum atl_type_kind)(-idxT);
		switch(s)
		{
		case atk_short:
		case atk_unsigned_short:
			return sizeof(short);
		case atk_int:
		case atk_unsigned_int:
			return sizeof(int);
		case atk_long:
		case atk_unsigned_long:
			return sizeof(long);
		case atk_long_long:
		case atk_unsigned_long_long:
			return sizeof(long long);
		case atk_int128:
		case atk_unsigned_int128:
			return 16;
		case atk_float:
#if MNTUSE_FLOAT
			return sizeof(float);
#endif
		case atk_double:     
#if MNTUSE_DOUBLE
			return sizeof(double);
#endif
		case atk_long_double:     
#if MNTUSE_DOUBLE
			return sizeof(long double);
#endif
		case atk_int32:
		case atk_unsigned_int32:
			return 4;
		case atk_char:
		case atk_signed_char:
		case atk_unsigned_char:
		case atk_string:
		default:
			return sizeof(char);
		}
	}
	else if(idxF < VARSTRUCSIZETABLE_SIZE)
	{
		const short * ps1=structsizeofTable[idxF];
		return ps1[idxT];//sizeof given into src file
	}
	return (RTRT_U_INT16)0;
}


char* mnt_addressOfVar(RTRT_U_INT16 idxF,RTRT_U_INT16 idxV,RTRT_U_INT8 nbDim, RTRT_INT16 * idxSizes,RTRT_U_INT32 *reqIndexes)
{
 if(idxF < VARADDRESSTABLE_SIZE) 
 {	 
	const void**	p2=varAddressTable[idxF];
	char* address = (char*)p2[idxV];
	while(nbDim--)
		address += (mnt_sizeOfElement(idxF,idxSizes[nbDim])*reqIndexes[nbDim]);
	return address;
 }
 return (char*)0;
}
/*
mnt_Read_Data read required data of type given by idxDataType at address 
convert the value in string fromat into res buffer
return the length of the generated string
*/
int mnt_Read_Data(RTRT_U_INT16 idxF, char* address, RTRT_INT8 idxDataType, char* res)
{
	
  if(address)
	if(idxDataType<0)
	{
		enum atl_type_kind s=(enum atl_type_kind)(-idxDataType);
		switch(s)
		{
		case atk_short:
		{
			short *p=(short*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_unsigned_short:
		{
			unsigned short *p=(unsigned short*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		case atk_int:
		{
			int *p=(int*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_unsigned_int:
		{
			unsigned int *p=(unsigned int*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		case atk_long:
		{
			long *p=(long*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_unsigned_long:
		{
			unsigned long *p=(unsigned long*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		case atk_int128:
		{
			_ATL_LARGEST_INT *p=(_ATL_LARGEST_INT*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_long_long:
		{
			long long *p=(long long*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_unsigned_int128:
		{
			_ATL_LARGEST_U_INT *p=(_ATL_LARGEST_U_INT*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		case atk_unsigned_long_long:
		{
			unsigned long long *p=(unsigned long long*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		case atk_int32:
		{
			RTRT_INT32 *p=(RTRT_INT32*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_unsigned_int32:
		{
			RTRT_U_INT32 *p=(RTRT_U_INT32*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		case atk_float:
#if MNTUSE_FLOAT && defined NEEDS_float_image
		{
			float *p=(float*)address;
			return(float_image(*p,res));
		}
#endif /*NEEDS_float_image*/
		case atk_double:     
#if MNTUSE_DOUBLE && defined NEEDS_double_image
		{
			double *p=(double*)address;
			return(double_image(*p,res));
	}
#endif /*NEEDS_double_image*/
		case atk_long_double:     
#if MNTUSE_DOUBLE && defined NEEDS_long_double_image
		{
			long double *p=(long double*)address;
			return(long_double_image(*p,res));
		}
#else /*NEEDS_long_double_image*/
		{
			int l=sizeof("Not Supported");
			char *p=     "Not Supported";
			int x;
			for(x=0;x<l;x++) res[x]=p[x];
			return l;
		}
#endif /*NEEDS_long_double_image*/
#ifdef NEED_char_image
		case atk_char:
		{
			char *p=(char*)address;
			return(char_image(*p,res));
		}
#endif /*NEED_char_image*/
		case atk_signed_char:
		{
			signed char *p=(signed char*)address;
			return(MNT_INTEGER_IMAGE(*p, res));
		}
		case atk_string:
		{
			char *p=(char*)address;
			
			break;
		}
		default:
		case atk_unsigned_char:
		{
			unsigned char *p=(unsigned char*)address;
			return(MNT_UNSIGNED_IMAGE(*p, res));
		}
		}
	}
	else
	{ /* for bitfields the final type is a struct */
		/* not yet tested */
		const short * ps1=structsizeofTable[idxF];
		unsigned char *p=(unsigned char*)address;
		RTRT_U_INT16 l=ps1[idxDataType];//sizeof given into src file
		int r=0;
		while(l-- >0)
		{
#ifdef RTRT_BIG_ENDIAN
			*res++ = ATL_HEXA_DIGITS((RTRT_U_INT8)((*p)>>4));
			*res++ = ATL_HEXA_DIGITS((RTRT_U_INT8)((*p++)&0xF));
#else /*RTRT_BIG_ENDIAN*/
			*res++ = ATL_HEXA_DIGITS((RTRT_U_INT8)((p[l])>>4));
			*res++ = ATL_HEXA_DIGITS((RTRT_U_INT8)((p[l])&0xF));
#endif /*RTRT_BIG_ENDIAN*/
			r++;
		}
		return r*2;
	}	
	return 0;
}
/*
mnt_Write_Data write the data given by 'in' parameter in string format
return the len of the string value found in 'in'
*/
int mnt_Write_Data(RTRT_U_INT16 idxF, char* address, RTRT_INT8 idxDataType, char* in)
{
	int ret=0;
	if(idxDataType<0)
	{
		enum atl_type_kind s=(enum atl_type_kind)(-idxDataType);
		switch(s)
		{
		case atk_short:
		{
			short *p=(short*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=(short)v;
			break;
		}
		case atk_unsigned_short:
		{
			unsigned short *p=(unsigned short*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=(unsigned short)v;
			break;
		}
		case atk_int:
		{
			int *p=(int*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=(int)v;
			break;
		}
		case atk_unsigned_int:
		{
			unsigned int *p=(unsigned int*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=(unsigned int)v;
			break;
		}
		case atk_long:
		{
			long *p=(long*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=(long)v;
			break;
		}
		case atk_unsigned_long:
		{
			unsigned long *p=(unsigned long*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=(unsigned long)v;
			break;
		}
		case atk_int128:
		{
			_ATL_LARGEST_INT *p=(_ATL_LARGEST_INT*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=v;
			break;
		}
		case atk_long_long:
		{
			long long *p=(long long*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=(long long)v;
			break;
		}
		case atk_unsigned_int128:
		{
			_ATL_LARGEST_U_INT *p=(_ATL_LARGEST_U_INT*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=v;
			break;
		}
		case atk_unsigned_long_long:
		{
			unsigned long long *p=(unsigned long long*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=(unsigned long long)v;
			break;
		}
		case atk_int32:
		{
			RTRT_INT32 *p=(RTRT_INT32*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=(RTRT_INT32)v;
			break;
		}
		case atk_unsigned_int32:
		{
			RTRT_U_INT32 *p=(RTRT_U_INT32*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=(RTRT_U_INT32)v;
			break;
		}
		case atk_float:
#if MNTUSE_FLOAT && defined NEEDS_float_image
		{
			float *p=(float*)address;
			NEEDS_priv_atof_type f;
			priv_atof(in,&ret,&f);
			*p=(float)f;
			break;
		}
#endif /*NEEDS_float_image*/
		case atk_double:     
#if MNTUSE_DOUBLE && defined NEEDS_double_image
		{
			double *p=(double*)address;
			NEEDS_priv_atof_type f;
			priv_atof(in,&ret,&f);
			*p=(double)f;
			break;
		}
#endif /*NEEDS_double_image*/
		case atk_long_double:     
		{
#if MNTUSE_DOUBLE && defined NEEDS_long_double_image
			long double *p=(long double*)address;
			NEEDS_priv_atof_type f;
			priv_atof(in,&ret,&f);
			*p=(long double)f;
#else /*NEEDS_long_double_image*/
			while(*in >='+' && *in <='9' || (*in&0xDF) =='E') {ret++;in++;}
#endif /*NEEDS_long_double_image*/
			break;
		}
#ifdef NEED_char_image
		case atk_char:
		{
			char *p=*in;
			ret=1;
			break;
		}
#endif /*NEED_char_image*/
		case atk_signed_char:
		{
			signed char *p=(signed char*)address;
			_ATL_LARGEST_INT v=buf2int(in,&ret);
			*p=(signed char)v;
			break;
		}
		case atk_string:
		{
			char *p=(char*)address;
			if(*in=='"') {in++;ret++;}
			while(*in && *in!='"')
			{
				if(*in=='\\'){in++;ret++;}
				*p++=*in++;
				ret++;
			}
			*p=0;
			break;
		}
		default:
		case atk_unsigned_char:
		{
			unsigned char *p=(unsigned char*)address;
			_ATL_LARGEST_U_INT v=buf2uint(in,&ret);
			*p=(unsigned char)v;
		}
		}
	}
	else
	{ /* for bitfields the final type is a struct */
#ifdef NEEDS_MNT_BITFIELDS
#if MNT_BITFIELDSUPPORT==2
		/* here is code for read, Write is Not yet implemented */
		const short * ps1=structsizeofTable[idxF];
		unsigned char *p=(unsigned char*)address;
		RTRT_U_INT16 l=ps1[idxDataType];//sizeof given into src file
		while(l--)
			debug2("%02X",*p++);
#endif /* MNT_BITFIELDSUPPORT */
#endif /* NEEDS_MNT_BITFIELDS */
	}
	return ret;
}

/*******************************************************************************
*  Service: mnt_send
*  Goal: send str on socket/usr/file connection
*  input str terminates with newLine char
*  input len gives the number of char to dump including newLine char
*******************************************************************************/
void mnt_send(char*str,int len)
{
#if MNT_IO == RTRT_SOCKET
	send(mnt_conn,str,len,0);
#elif MNT_IO == RTRT_USR	
    mnt_usr_send(mnt_conn,str,len);
#else
    RTRT_MT_CRITICAL_VAR_LOCK(atl_line_mutex)

    ATL_LINE_ADD_OPCODE_SPACE (ATL_MNT_VV);
	while(len)
    {
		if(*str==',') atl_line_add_char(' ');
		else atl_line_add_char(*str);
		str++;
		len--;
    }
	/* Each line is immediatly dumped */
    atl_buffer_dump ();
    RTRT_MT_CRITICAL_VAR_UNLOCK(atl_line_mutex)
#endif /*MNT_IO*/
}

/*******************************************************************************
*  Service: mnt_readCyclicTable
*  Goal: read the cyclic table to read data when it is time to do it
*        buf is the print buffer given by the caller to write data response
*******************************************************************************/
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
void mnt_readCyclicTable(char *buf)
{
	_AtlCyclicTableP p;
	for(p=mnt_CyclicTableTop; p ; p=p->Next)
	{
		if(mnt_conn)
		{
			int l=MNT_UNSIGNED_IMAGE(p->idxR, buf);
			buf[l++]=',';
			l+=mnt_Read_Data(p->idxF,p->addressVar,p->idxDataType, &buf[l]);
			buf[l++]='\n';
			mnt_send(buf,l);
		}
		else
		{
			return; 
		}
	}
}

void mnt_stopCyclicRead(RTRT_U_INT16 idxR)
{
	_AtlCyclicTableP n=0;
	_AtlCyclicTableP p=mnt_CyclicTableTop;
	if(p)
	{
		if(p->idxR==idxR)
		{
			mnt_CyclicTableTop=p->Next;
			n=p;
		}
		else 
		{
			while(p->Next && p->Next->idxR!=idxR ) p=p->Next;
			if(p->Next && p->Next->idxR==idxR)
			{
				n=p->Next;
				p->Next=n->Next;
			}
		}
		if(n) 
		{
			debug2("stop: %d\n",n->idxR);
			priv_free(n);
		}
	}
}
#endif //MNT_CYCLIC_ALLOWED	
RTRT_INT16 mnt_idxSizes[MNT_MAX_DIM];
RTRT_U_INT32 mnt_Indexes[MNT_MAX_DIM];
void mnt_close();
/*******************************************************************************
* mnt_rec_cmd return the number of char in the request
* in input buffer for request. O<idxR>,<idxF>,<idxV>,<type>,<dim>....... 
* out output buffer must provide enough space for response. 
*     if out=0, response is copied into input buffer
* Orders are
* S : Stop
* W : Write
* F : Frequency
* R : Read
* C : Cyclic Read
* END : End connection
*******************************************************************************/
int mnt_rec_cmd(char* in,char* out)
{
char *pin;
int ret=0;
 if(in)
 {
	 RTRT_U_INT16 idxR;
	 RTRT_U_INT16 idxF;
	 RTRT_U_INT16 idxV;
	 RTRT_INT8 idxDataType;
	 RTRT_U_INT8 nbDim;
	 int dim=0;
#define state_ReqIdx 0
#define state_FileIdx 1
#define state_VarIdx 2
#define state_DataType 3
#define state_Dim 4
#define state_Sizes 5
#define state_Indexes 6
#define state_End 7
     int state=state_ReqIdx;
	 char c=0;
	 char neg=0;
	 RTRT_INT32 v=0;
	 char *res;
	 char operation=*in++;
	 pin=in;
	 ret++;
	while(*in)
	{
		c=*in++;
		ret++;
		if(c>='0' && c<='9') 
		{
			v=v*10+(c-'0');
			if(*in)
				continue;
		}
		else if(c == '-')
		{
			neg=1;
			continue;
		}
		switch(state)
		{
			case state_ReqIdx:
				idxR=(RTRT_U_INT16)v;
				state++;
				if(operation=='S' || operation=='E' || operation=='F') state=state_End;
				if(out)	
				{
					res=out;
					while(pin<in) *res++ = *pin++;
					pin=out;
				}
				else
					res=in;
				break;
			case state_FileIdx:
				idxF=(RTRT_U_INT16)v;
				state++;
				break;
			case state_VarIdx:
				idxV=(RTRT_U_INT16)v;
				state++;
				break;
			case state_DataType:
				if(neg) v=-v;
				idxDataType=(RTRT_INT8)v;
				state++;
				break;
			case state_Dim:
				nbDim=(RTRT_U_INT8)v;
				state++;
				if(nbDim==0)
					state+=2;
				dim=0;
				break;
			case state_Sizes:
				if(neg) v=-v;
				mnt_idxSizes[dim++]=(RTRT_INT16)v;
				if(dim>=nbDim)
				{
					state++;
					dim=0;
				}
				break;
			case state_Indexes:
				mnt_Indexes[dim++]=(RTRT_U_INT32)v;
				if(dim>=nbDim)
					state++;
				break;
			default:
				/* unexpected char in cmd */
				return ret;
		}
		neg=0;
		v=0;
		if(state==state_End)
			break;
	}
	if(state==state_End)
	{
	  if(operation=='R' || operation=='C')
	  {
		char * address=mnt_addressOfVar(idxF,idxV,nbDim,mnt_idxSizes,mnt_Indexes);
		res+=mnt_Read_Data(idxF,address,idxDataType, res);
		*res++ ='\n';
		mnt_send(pin,(res-pin));/* pin is the pointer to string (with nul terminator) res-pin is the length */
		if(operation=='C' && address)
		{
			mnt_Push2CyclicTable(idxR,idxF,idxDataType,address);
		}
	  }
	  else if(operation=='W')
	  {
		char *p=in;
		char * address=mnt_addressOfVar(idxF,idxV,nbDim,mnt_idxSizes,mnt_Indexes);
		//while(*p >',' && *p <='9') {ret++;p++;}
		ret+=mnt_Write_Data(idxF,address,idxDataType , in);
		res+=mnt_Read_Data(idxF,address,idxDataType, res);
		*res++ ='\n';
		mnt_send(pin,(res-pin));/* pin is the pointer to string (with nul terminator) res-pin is the length */
	  }
	  else if(operation=='S')
	  {
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
		  mnt_stopCyclicRead(idxR);
#endif
	  }
	  else if(operation=='F')
	  {
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
		  debug2("freq %d\n",idxR);
		  mnt_cycle=0;
		  mnt_frequency=(RTRT_U_INT16)(idxR);
#endif
	  }
	  else if(operation=='E' && *in == 'D') //END
	  {
		  ret++;
		  mnt_close();
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
		  while(mnt_CyclicTableTop)
		  {
			_AtlCyclicTableP p=mnt_CyclicTableTop;
			mnt_CyclicTableTop=mnt_CyclicTableTop->Next;
			priv_free(p);
		  }
#endif
	  } else {
		debug2("wrong request (%d)\n",state)		  
	  }
	}
	else
	{
		debug2("bad request (%d)\n",state)
	}
 }
return ret;
}

/*******************************************************************************
*  Service: mnt_close
*  Goal: close the way for mnt exchanges
*******************************************************************************/
void mnt_close()
{
#if MNT_IO == RTRT_SOCKET
#ifdef RTRT_WAIT_BEFORE_CLOSE
  RTRT_WAIT_BEFORE_CLOSE
#endif
#if _ATL_WIN32_API
  closesocket(mnt_conn);
  WSACleanup();
#else /* _ATL_WIN32_API */
  close(mnt_conn);
#endif /* _ATL_WIN32_API */
#elif MNT_IO == RTRT_USR
  mnt_usr_close(mnt_conn);
#endif /* MNT_IO */
mnt_conn=0;
printf("Disconnected\n");
}

/*******************************************************************************
*  Service: mnt_sock_open
*  Goal: initializes/open client socket connection
*******************************************************************************/
#if MNT_IO == RTRT_SOCKET //8
MNT_FILE_TYPE mnt_sock_open(void)
{
#if _ATL_WIN32_API
WSADATA   WSAData;
#endif /* _ATL_WIN32_API */
MNT_FILE_TYPE local_id;
unsigned char hostaddress[]={ATL_HOST_ADDRESS_NS};
struct sockaddr_in local_mbx;
int ret;
#if _ATL_WIN32_API
if (WSAStartup (MAKEWORD (1, 1), &WSAData) != 0) return(0);
#endif /* _ATL_WIN32_API */
memset ((void *) &local_mbx, 0, sizeof(struct sockaddr_in));
memcpy ((void *) &local_mbx.sin_addr, hostaddress, sizeof(hostaddress));
local_mbx.sin_family = AF_INET;
local_mbx.sin_port = (unsigned short)(htons(MNT_HOST_ADDRESS_PORT));
/* Create a new socket */
local_id = socket (AF_INET, SOCK_STREAM, 0);
if (local_id<0) return(0);
/* Connect it to the Server port */
ret = connect(local_id, (struct sockaddr *)&local_mbx, sizeof(struct sockaddr_in));
if (ret!=0) 
{
#if _ATL_WIN32_API
  closesocket(local_id);
  WSACleanup();
#else /* _ATL_WIN32_API */
  close(local_id);
#endif /* _ATL_WIN32_API */
  return(0);
}
/* Stores the new socket in the id parameter */
#ifdef RTRT_BIG_ENDIAN
mnt_send("BE\n",3);
#endif
printf("connected\n");
return(local_id);
}

/*******************************************************************************
*  Service: mnt_get_request
*  Goal: get request from socket connection
*  buffer=received message, maxlen= size of the declared buffer, timeout in ms
*******************************************************************************/
int mnt_get_request (char *buffer, int maxlen, int timeout)
{
  int       ret;
  fd_set    fds;
  struct timeval tv;


  /* If not init, error */
  if (mnt_conn==0)
  {  
	mnt_conn=mnt_sock_open();
	if(mnt_conn==0) return 0;
  }

  /* Put the socket id in the fd set */
  FD_ZERO(&fds);
  FD_SET(mnt_conn,&fds);

  tv.tv_sec=timeout/1000;
  tv.tv_usec=(timeout%1000)*1000;

  select(FD_SETSIZE,&fds,NULL,NULL,&tv);

  /* If no fd is set : there is no message to read */
  if (!FD_ISSET(mnt_conn,&fds)) return(0);

  /* In the case the fd is set, read the message */
  ret = recv (mnt_conn, buffer, maxlen,0);
  if (ret < 0)
   if (errno == EINTR) return(0);
   else
   {
	   mnt_close();
	   return(0);
   }
  return (ret);
}
#else
// NONE 0=use of atl_buffer and TDP mechanism, 1=use STD|FILE, 3=external usr code
int mnt_get_request (char *buffer, int maxlen, int timeout)
{
  int       ret=0;
  /* If not init, error */
  if (mnt_conn==0)
  {  
	mnt_conn=mnt_open();
	if(mnt_conn==0) return 0;
  }
#if MNT_IO == RTRT_USR
  //external usr code
  ret=mnt_usr_get_request(mnt_conn,buffer, maxlen, timeout);
#elif MNT_IO == RTRT_STD
//1=use STD|FILE
  {
  char* line;
  size_t len;
  do
  {
    if(getline(&line, &len, mnt_conn) !=-1)
	  return (int)len;
    lseek(mnt_conn,0,SEEK_DATA);
  }while(timeout--);
  }
#endif /*MNT_IO*/
  return (ret);
}
#endif /* RTRT_IO == RTRT_SOCKET */

/*******************************************************************************
*  Service: mnt_open
*  Goal: opens the way for mnt exchanges 
*******************************************************************************/
int mnt_open(char *fileName)
{
#if MNT_IO == RTRT_SOCKET
mnt_conn = mnt_sock_open();
#ifdef RTRT_BIG_ENDIAN
if(mnt_conn) mnt_send("BE\n",3);
#endif
return (mnt_conn!=0);
#elif MNT_IO == RTRT_USR
mnt_conn = mnt_usr_open(fileName);
#ifdef RTRT_BIG_ENDIAN
if(mnt_conn) mnt_send("BE\n",3);
#endif
return (mnt_conn!=0);
#elif MNT_IO == RTRT_STD
mnt_conn =fopen(fileName,"r"));/* read order from file, write result into atl_buffer */
#endif
#ifdef RTRT_BIG_ENDIAN
if(mnt_conn) mnt_send("BE\n",3);
#endif

return 1;
}
/*******************************************************************************
*  Service: mnt_exec_request
*  Goal: This method is called in the main forever loop of the application 
*		 or into a cyclic task, in order to give control to monitoring code cyclically.
*******************************************************************************/
void mnt_exec_request(void)
{
	int len;
	int x=0;
	if ( ! _ATL_INITIALIZED )
	{
    /* This branch is reached once in the process life */
		atl_early_init ( );
	}
		/*get request from UI into mnt_out_buffer*/
#if MNT_IO == RTRT_NONE
#ifdef MNT_EXEC_REQUEST_NONE
MNT_EXEC_REQUEST_NONE();
#endif
#else
//printf("mnt_get_request ");
	while(len=mnt_get_request(mnt_input_buffer,MNT_INPUT_BUFFER_SIZE,0))
	{
		mnt_input_buffer[len]=0;
//		printf("%d [%c]\n",len,mnt_input_buffer[x]);
		while(x<len){
			if(mnt_input_buffer[x]>='C' && mnt_input_buffer[x]<='W')
			{
//				printf(".%d>%s\n",x,&mnt_input_buffer[x]);
				/* out: provide a buffer for ouput or 0 if response can be written into request buffer
				*/
				x+= mnt_rec_cmd(&mnt_input_buffer[x],mnt_out_buffer);
			}
			else
			{
				x++;
			}
		}	
	}
#endif /* MNT_IO */
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
	if(mnt_cycle-- ==0) 
	{
		mnt_cycle=mnt_frequency;
		mnt_readCyclicTable(mnt_out_buffer);
	}
#endif /*MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE*/
}


/*******************************************************************************
*  Service: atn_early_init
*  Goal: initializes global variables
*******************************************************************************/
_ATL_C_GLOBALFCT void mnt_early_init
#if !RTRT_KR
( void )
#else
( )
#endif
{
#ifdef MNT_FILE_TYPE
 mnt_conn=0;
#endif /*MNT_FILE_TYPE*/
#if MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE
mnt_CyclicTableTop=0;
mnt_cycle=MNT_FREQUENCY;
mnt_frequency=MNT_FREQUENCY;
#endif /*MNT_CYCLIC_ALLOWED && RTRT_HEAP!=RTRT_NONE*/
}

/*******************************************************************************
*  Service: atn_late_exit atn_exit_pending
*  Goal: called when it is time to quit
*******************************************************************************/
_ATL_C_GLOBALFCT void mnt_late_exit
#if !RTRT_KR
( void )
#else
( )
#endif
{
	if(mnt_conn) mnt_close();
}
